diff --git a/src/backend/access/transam/twophase.c b/src/backend/access/transam/twophase.c
new file mode 100644
index e9751aa..77d6bf2
*** a/src/backend/access/transam/twophase.c
--- b/src/backend/access/transam/twophase.c
*************** TwoPhaseGetGXact(TransactionId xid)
*** 836,842 ****
  	LWLockRelease(TwoPhaseStateLock);
  
  	if (result == NULL)			/* should not happen */
! 		elog(ERROR, "failed to find GlobalTransaction for xid %u", xid);
  
  	cached_xid = xid;
  	cached_gxact = result;
--- 836,842 ----
  	LWLockRelease(TwoPhaseStateLock);
  
  	if (result == NULL)			/* should not happen */
! 		elog(ERROR, "failed to find GlobalTransaction for xid " XID_FMT, xid);
  
  	cached_xid = xid;
  	cached_gxact = result;
*************** TwoPhaseGetDummyProc(TransactionId xid)
*** 877,883 ****
  /************************************************************************/
  
  #define TwoPhaseFilePath(path, xid) \
! 	snprintf(path, MAXPGPATH, TWOPHASE_DIR "/%08X", xid)
  
  /*
   * 2PC state file format:
--- 877,883 ----
  /************************************************************************/
  
  #define TwoPhaseFilePath(path, xid) \
! 	snprintf(path, MAXPGPATH, TWOPHASE_DIR "/%08X%08X", (uint32)(xid >> 32), (uint32)xid)
  
  /*
   * 2PC state file format:
*************** restoreTwoPhaseData(void)
*** 1739,1751 ****
  	LWLockAcquire(TwoPhaseStateLock, LW_EXCLUSIVE);
  	while ((clde = ReadDir(cldir, TWOPHASE_DIR)) != NULL)
  	{
! 		if (strlen(clde->d_name) == 8 &&
! 			strspn(clde->d_name, "0123456789ABCDEF") == 8)
  		{
  			TransactionId xid;
  			char	   *buf;
  
! 			xid = (TransactionId) strtoul(clde->d_name, NULL, 16);
  
  			buf = ProcessTwoPhaseBuffer(xid, InvalidXLogRecPtr,
  										true, false, false);
--- 1739,1751 ----
  	LWLockAcquire(TwoPhaseStateLock, LW_EXCLUSIVE);
  	while ((clde = ReadDir(cldir, TWOPHASE_DIR)) != NULL)
  	{
! 		if (strlen(clde->d_name) == 16 &&
! 			strspn(clde->d_name, "0123456789ABCDEF") == 16)
  		{
  			TransactionId xid;
  			char	   *buf;
  
! 			xid = (TransactionId) pg_strtouint64(clde->d_name, NULL, 16);
  
  			buf = ProcessTwoPhaseBuffer(xid, InvalidXLogRecPtr,
  										true, false, false);
*************** RecoverPreparedTransactions(void)
*** 1941,1947 ****
  			continue;
  
  		ereport(LOG,
! 				(errmsg("recovering prepared transaction %u from shared memory", xid)));
  
  		hdr = (TwoPhaseFileHeader *) buf;
  		Assert(TransactionIdEquals(hdr->xid, xid));
--- 1941,1947 ----
  			continue;
  
  		ereport(LOG,
! 				(errmsg("recovering prepared transaction " XID_FMT " from shared memory", xid)));
  
  		hdr = (TwoPhaseFileHeader *) buf;
  		Assert(TransactionIdEquals(hdr->xid, xid));
*************** ProcessTwoPhaseBuffer(TransactionId xid,
*** 2031,2044 ****
  		if (fromdisk)
  		{
  			ereport(WARNING,
! 					(errmsg("removing stale two-phase state file for \"%u\"",
  							xid)));
  			RemoveTwoPhaseFile(xid, true);
  		}
  		else
  		{
  			ereport(WARNING,
! 					(errmsg("removing stale two-phase state from shared memory for \"%u\"",
  							xid)));
  			PrepareRedoRemove(xid, true);
  		}
--- 2031,2044 ----
  		if (fromdisk)
  		{
  			ereport(WARNING,
! 					(errmsg("removing stale two-phase state file for \"" XID_FMT "\"",
  							xid)));
  			RemoveTwoPhaseFile(xid, true);
  		}
  		else
  		{
  			ereport(WARNING,
! 					(errmsg("removing stale two-phase state from shared memory for \"" XID_FMT "\"",
  							xid)));
  			PrepareRedoRemove(xid, true);
  		}
*************** ProcessTwoPhaseBuffer(TransactionId xid,
*** 2051,2064 ****
  		if (fromdisk)
  		{
  			ereport(WARNING,
! 					(errmsg("removing future two-phase state file for \"%u\"",
  							xid)));
  			RemoveTwoPhaseFile(xid, true);
  		}
  		else
  		{
  			ereport(WARNING,
! 			(errmsg("removing future two-phase state from memory for \"%u\"",
  					xid)));
  			PrepareRedoRemove(xid, true);
  		}
--- 2051,2064 ----
  		if (fromdisk)
  		{
  			ereport(WARNING,
! 					(errmsg("removing future two-phase state file for \"" XID_FMT "\"",
  							xid)));
  			RemoveTwoPhaseFile(xid, true);
  		}
  		else
  		{
  			ereport(WARNING,
! 			(errmsg("removing future two-phase state from memory for \"" XID_FMT "\"",
  					xid)));
  			PrepareRedoRemove(xid, true);
  		}
*************** ProcessTwoPhaseBuffer(TransactionId xid,
*** 2072,2078 ****
  		if (buf == NULL)
  		{
  			ereport(WARNING,
! 				  (errmsg("removing corrupt two-phase state file for \"%u\"",
  						  xid)));
  			RemoveTwoPhaseFile(xid, true);
  			return NULL;
--- 2072,2078 ----
  		if (buf == NULL)
  		{
  			ereport(WARNING,
! 				  (errmsg("removing corrupt two-phase state file for \"" XID_FMT "\"",
  						  xid)));
  			RemoveTwoPhaseFile(xid, true);
  			return NULL;
*************** ProcessTwoPhaseBuffer(TransactionId xid,
*** 2091,2104 ****
  		if (fromdisk)
  		{
  			ereport(WARNING,
! 				  (errmsg("removing corrupt two-phase state file for \"%u\"",
  						  xid)));
  			RemoveTwoPhaseFile(xid, true);
  		}
  		else
  		{
  			ereport(WARNING,
! 			(errmsg("removing corrupt two-phase state from memory for \"%u\"",
  					xid)));
  			PrepareRedoRemove(xid, true);
  		}
--- 2091,2104 ----
  		if (fromdisk)
  		{
  			ereport(WARNING,
! 				  (errmsg("removing corrupt two-phase state file for \"" XID_FMT "\"",
  						  xid)));
  			RemoveTwoPhaseFile(xid, true);
  		}
  		else
  		{
  			ereport(WARNING,
! 			(errmsg("removing corrupt two-phase state from memory for \"" XID_FMT "\"",
  					xid)));
  			PrepareRedoRemove(xid, true);
  		}
*************** RecordTransactionAbortPrepared(Transacti
*** 2264,2270 ****
  	 * RecordTransactionCommitPrepared ...
  	 */
  	if (TransactionIdDidCommit(xid))
! 		elog(PANIC, "cannot abort transaction %u, it was already committed",
  			 xid);
  
  	START_CRIT_SECTION();
--- 2264,2270 ----
  	 * RecordTransactionCommitPrepared ...
  	 */
  	if (TransactionIdDidCommit(xid))
! 		elog(PANIC, "cannot abort transaction " XID_FMT ", it was already committed",
  			 xid);
  
  	START_CRIT_SECTION();
*************** PrepareRedoAdd(char *buf, XLogRecPtr sta
*** 2358,2364 ****
  	Assert(TwoPhaseState->numPrepXacts < max_prepared_xacts);
  	TwoPhaseState->prepXacts[TwoPhaseState->numPrepXacts++] = gxact;
  
! 	elog(DEBUG2, "added 2PC data in shared memory for transaction %u", gxact->xid);
  }
  
  /*
--- 2358,2364 ----
  	Assert(TwoPhaseState->numPrepXacts < max_prepared_xacts);
  	TwoPhaseState->prepXacts[TwoPhaseState->numPrepXacts++] = gxact;
  
! 	elog(DEBUG2, "added 2PC data in shared memory for transaction " XID_FMT, gxact->xid);
  }
  
  /*
*************** PrepareRedoRemove(TransactionId xid, boo
*** 2401,2407 ****
  	/*
  	 * And now we can clean up any files we may have left.
  	 */
! 	elog(DEBUG2, "removing 2PC data for transaction %u", xid);
  	if (gxact->ondisk)
  		RemoveTwoPhaseFile(xid, giveWarning);
  	RemoveGXact(gxact);
--- 2401,2407 ----
  	/*
  	 * And now we can clean up any files we may have left.
  	 */
! 	elog(DEBUG2, "removing 2PC data for transaction " XID_FMT, xid);
  	if (gxact->ondisk)
  		RemoveTwoPhaseFile(xid, giveWarning);
  	RemoveGXact(gxact);
diff --git a/src/backend/access/transam/varsup.c b/src/backend/access/transam/varsup.c
new file mode 100644
index b02dd6f..7dc26bb
*** a/src/backend/access/transam/varsup.c
--- b/src/backend/access/transam/varsup.c
*************** GetNewTransactionId(bool isSubXact)
*** 97,107 ****
  		 * possibility of deadlock while doing get_database_name(). First,
  		 * copy all the shared values we'll need in this path.
  		 */
- 		TransactionId xidWarnLimit = ShmemVariableCache->xidWarnLimit;
- 		TransactionId xidStopLimit = ShmemVariableCache->xidStopLimit;
- 		TransactionId xidWrapLimit = ShmemVariableCache->xidWrapLimit;
- 		Oid			oldest_datoid = ShmemVariableCache->oldestXidDB;
- 
  		LWLockRelease(XidGenLock);
  
  		/*
--- 97,102 ----
*************** GetNewTransactionId(bool isSubXact)
*** 112,159 ****
  		if (IsUnderPostmaster && (xid % 65536) == 0)
  			SendPostmasterSignal(PMSIGNAL_START_AUTOVAC_LAUNCHER);
  
- 		if (IsUnderPostmaster &&
- 			TransactionIdFollowsOrEquals(xid, xidStopLimit))
- 		{
- 			char	   *oldest_datname = get_database_name(oldest_datoid);
- 
- 			/* complain even if that DB has disappeared */
- 			if (oldest_datname)
- 				ereport(ERROR,
- 						(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
- 						 errmsg("database is not accepting commands to avoid wraparound data loss in database \"%s\"",
- 								oldest_datname),
- 						 errhint("Stop the postmaster and vacuum that database in single-user mode.\n"
- 								 "You might also need to commit or roll back old prepared transactions.")));
- 			else
- 				ereport(ERROR,
- 						(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
- 						 errmsg("database is not accepting commands to avoid wraparound data loss in database with OID %u",
- 								oldest_datoid),
- 						 errhint("Stop the postmaster and vacuum that database in single-user mode.\n"
- 								 "You might also need to commit or roll back old prepared transactions.")));
- 		}
- 		else if (TransactionIdFollowsOrEquals(xid, xidWarnLimit))
- 		{
- 			char	   *oldest_datname = get_database_name(oldest_datoid);
- 
- 			/* complain even if that DB has disappeared */
- 			if (oldest_datname)
- 				ereport(WARNING,
- 						(errmsg("database \"%s\" must be vacuumed within %u transactions",
- 								oldest_datname,
- 								xidWrapLimit - xid),
- 						 errhint("To avoid a database shutdown, execute a database-wide VACUUM in that database.\n"
- 								 "You might also need to commit or roll back old prepared transactions.")));
- 			else
- 				ereport(WARNING,
- 						(errmsg("database with OID %u must be vacuumed within %u transactions",
- 								oldest_datoid,
- 								xidWrapLimit - xid),
- 						 errhint("To avoid a database shutdown, execute a database-wide VACUUM in that database.\n"
- 								 "You might also need to commit or roll back old prepared transactions.")));
- 		}
- 
  		/* Re-acquire lock and start over */
  		LWLockAcquire(XidGenLock, LW_EXCLUSIVE);
  		xid = ShmemVariableCache->nextXid;
--- 107,112 ----
*************** void
*** 288,338 ****
  SetTransactionIdLimit(TransactionId oldest_datfrozenxid, Oid oldest_datoid)
  {
  	TransactionId xidVacLimit;
- 	TransactionId xidWarnLimit;
- 	TransactionId xidStopLimit;
- 	TransactionId xidWrapLimit;
  	TransactionId curXid;
  
  	Assert(TransactionIdIsNormal(oldest_datfrozenxid));
  
  	/*
- 	 * The place where we actually get into deep trouble is halfway around
- 	 * from the oldest potentially-existing XID.  (This calculation is
- 	 * probably off by one or two counts, because the special XIDs reduce the
- 	 * size of the loop a little bit.  But we throw in plenty of slop below,
- 	 * so it doesn't matter.)
- 	 */
- 	xidWrapLimit = oldest_datfrozenxid + (MaxTransactionId >> 1);
- 	if (xidWrapLimit < FirstNormalTransactionId)
- 		xidWrapLimit += FirstNormalTransactionId;
- 
- 	/*
- 	 * We'll refuse to continue assigning XIDs in interactive mode once we get
- 	 * within 1M transactions of data loss.  This leaves lots of room for the
- 	 * DBA to fool around fixing things in a standalone backend, while not
- 	 * being significant compared to total XID space. (Note that since
- 	 * vacuuming requires one transaction per table cleaned, we had better be
- 	 * sure there's lots of XIDs left...)
- 	 */
- 	xidStopLimit = xidWrapLimit - 1000000;
- 	if (xidStopLimit < FirstNormalTransactionId)
- 		xidStopLimit -= FirstNormalTransactionId;
- 
- 	/*
- 	 * We'll start complaining loudly when we get within 10M transactions of
- 	 * the stop point.  This is kind of arbitrary, but if you let your gas
- 	 * gauge get down to 1% of full, would you be looking for the next gas
- 	 * station?  We need to be fairly liberal about this number because there
- 	 * are lots of scenarios where most transactions are done by automatic
- 	 * clients that won't pay attention to warnings. (No, we're not gonna make
- 	 * this configurable.  If you know enough to configure it, you know enough
- 	 * to not get in this kind of trouble in the first place.)
- 	 */
- 	xidWarnLimit = xidStopLimit - 10000000;
- 	if (xidWarnLimit < FirstNormalTransactionId)
- 		xidWarnLimit -= FirstNormalTransactionId;
- 
- 	/*
  	 * We'll start trying to force autovacuums when oldest_datfrozenxid gets
  	 * to be more than autovacuum_freeze_max_age transactions old.
  	 *
--- 241,251 ----
*************** SetTransactionIdLimit(TransactionId olde
*** 355,372 ****
  	LWLockAcquire(XidGenLock, LW_EXCLUSIVE);
  	ShmemVariableCache->oldestXid = oldest_datfrozenxid;
  	ShmemVariableCache->xidVacLimit = xidVacLimit;
- 	ShmemVariableCache->xidWarnLimit = xidWarnLimit;
- 	ShmemVariableCache->xidStopLimit = xidStopLimit;
- 	ShmemVariableCache->xidWrapLimit = xidWrapLimit;
  	ShmemVariableCache->oldestXidDB = oldest_datoid;
  	curXid = ShmemVariableCache->nextXid;
  	LWLockRelease(XidGenLock);
  
- 	/* Log the info */
- 	ereport(DEBUG1,
- 			(errmsg("transaction ID wrap limit is %u, limited by database with OID %u",
- 					xidWrapLimit, oldest_datoid)));
- 
  	/*
  	 * If past the autovacuum force point, immediately signal an autovac
  	 * request.  The reason for this is that autovac only processes one
--- 268,277 ----
*************** SetTransactionIdLimit(TransactionId olde
*** 377,417 ****
  	if (TransactionIdFollowsOrEquals(curXid, xidVacLimit) &&
  		IsUnderPostmaster && !InRecovery)
  		SendPostmasterSignal(PMSIGNAL_START_AUTOVAC_LAUNCHER);
- 
- 	/* Give an immediate warning if past the wrap warn point */
- 	if (TransactionIdFollowsOrEquals(curXid, xidWarnLimit) && !InRecovery)
- 	{
- 		char	   *oldest_datname;
- 
- 		/*
- 		 * We can be called when not inside a transaction, for example during
- 		 * StartupXLOG().  In such a case we cannot do database access, so we
- 		 * must just report the oldest DB's OID.
- 		 *
- 		 * Note: it's also possible that get_database_name fails and returns
- 		 * NULL, for example because the database just got dropped.  We'll
- 		 * still warn, even though the warning might now be unnecessary.
- 		 */
- 		if (IsTransactionState())
- 			oldest_datname = get_database_name(oldest_datoid);
- 		else
- 			oldest_datname = NULL;
- 
- 		if (oldest_datname)
- 			ereport(WARNING,
- 			(errmsg("database \"%s\" must be vacuumed within %u transactions",
- 					oldest_datname,
- 					xidWrapLimit - curXid),
- 			 errhint("To avoid a database shutdown, execute a database-wide VACUUM in that database.\n"
- 					 "You might also need to commit or roll back old prepared transactions.")));
- 		else
- 			ereport(WARNING,
- 					(errmsg("database with OID %u must be vacuumed within %u transactions",
- 							oldest_datoid,
- 							xidWrapLimit - curXid),
- 					 errhint("To avoid a database shutdown, execute a database-wide VACUUM in that database.\n"
- 							 "You might also need to commit or roll back old prepared transactions.")));
- 	}
  }
  
  
--- 282,287 ----
diff --git a/src/backend/access/transam/xact.c b/src/backend/access/transam/xact.c
new file mode 100644
index e09696c..40f05f7
*** a/src/backend/access/transam/xact.c
--- b/src/backend/access/transam/xact.c
*************** RecordTransactionAbort(bool isSubXact)
*** 1563,1569 ****
  	 * Check that we haven't aborted halfway through RecordTransactionCommit.
  	 */
  	if (TransactionIdDidCommit(xid))
! 		elog(PANIC, "cannot abort transaction %u, it was already committed",
  			 xid);
  
  	/* Fetch the data we need for the abort record */
--- 1563,1569 ----
  	 * Check that we haven't aborted halfway through RecordTransactionCommit.
  	 */
  	if (TransactionIdDidCommit(xid))
! 		elog(PANIC, "cannot abort transaction " XID_FMT ", it was already committed",
  			 xid);
  
  	/* Fetch the data we need for the abort record */
*************** ShowTransactionStateRec(const char *str,
*** 4973,4981 ****
  	{
  		int			i;
  
! 		appendStringInfo(&buf, ", children: %u", s->childXids[0]);
  		for (i = 1; i < s->nChildXids; i++)
! 			appendStringInfo(&buf, " %u", s->childXids[i]);
  	}
  
  	if (s->parent)
--- 4973,4981 ----
  	{
  		int			i;
  
! 		appendStringInfo(&buf, ", children: " XID_FMT, s->childXids[0]);
  		for (i = 1; i < s->nChildXids; i++)
! 			appendStringInfo(&buf, " " XID_FMT, s->childXids[i]);
  	}
  
  	if (s->parent)
*************** ShowTransactionStateRec(const char *str,
*** 4983,4995 ****
  
  	/* use ereport to suppress computation if msg will not be printed */
  	ereport(DEBUG5,
! 			(errmsg_internal("%s(%d) name: %s; blockState: %s; state: %s, xid/subid/cid: %u/%u/%u%s%s",
  							 str, s->nestingLevel,
  							 PointerIsValid(s->name) ? s->name : "unnamed",
  							 BlockStateAsString(s->blockState),
  							 TransStateAsString(s->state),
! 							 (unsigned int) s->transactionId,
! 							 (unsigned int) s->subTransactionId,
  							 (unsigned int) currentCommandId,
  							 currentCommandIdUsed ? " (used)" : "",
  							 buf.data)));
--- 4983,4995 ----
  
  	/* use ereport to suppress computation if msg will not be printed */
  	ereport(DEBUG5,
! 			(errmsg_internal("%s(%d) name: %s; blockState: %s; state: %s, xid/subid/cid: " XID_FMT "/" XID_FMT "/%u%s%s",
  							 str, s->nestingLevel,
  							 PointerIsValid(s->name) ? s->name : "unnamed",
  							 BlockStateAsString(s->blockState),
  							 TransStateAsString(s->state),
! 							 s->transactionId,
! 							 s->subTransactionId,
  							 (unsigned int) currentCommandId,
  							 currentCommandIdUsed ? " (used)" : "",
  							 buf.data)));
*************** XactLogCommitRecord(TimestampTz commit_t
*** 5118,5126 ****
  	xl_xact_xinfo xl_xinfo;
  	xl_xact_dbinfo xl_dbinfo;
  	xl_xact_subxacts xl_subxacts;
  	xl_xact_relfilenodes xl_relfilenodes;
  	xl_xact_invals xl_invals;
- 	xl_xact_twophase xl_twophase;
  	xl_xact_origin xl_origin;
  
  	uint8		info;
--- 5118,5126 ----
  	xl_xact_xinfo xl_xinfo;
  	xl_xact_dbinfo xl_dbinfo;
  	xl_xact_subxacts xl_subxacts;
+ 	xl_xact_twophase xl_twophase;
  	xl_xact_relfilenodes xl_relfilenodes;
  	xl_xact_invals xl_invals;
  	xl_xact_origin xl_origin;
  
  	uint8		info;
*************** XactLogCommitRecord(TimestampTz commit_t
*** 5170,5175 ****
--- 5170,5181 ----
  		xl_subxacts.nsubxacts = nsubxacts;
  	}
  
+ 	if (TransactionIdIsValid(twophase_xid))
+ 	{
+ 		xl_xinfo.xinfo |= XACT_XINFO_HAS_TWOPHASE;
+ 		xl_twophase.xid = twophase_xid;
+ 	}
+ 
  	if (nrels > 0)
  	{
  		xl_xinfo.xinfo |= XACT_XINFO_HAS_RELFILENODES;
*************** XactLogCommitRecord(TimestampTz commit_t
*** 5182,5193 ****
  		xl_invals.nmsgs = nmsgs;
  	}
  
- 	if (TransactionIdIsValid(twophase_xid))
- 	{
- 		xl_xinfo.xinfo |= XACT_XINFO_HAS_TWOPHASE;
- 		xl_twophase.xid = twophase_xid;
- 	}
- 
  	/* dump transaction origin information */
  	if (replorigin_session_origin != InvalidRepOriginId)
  	{
--- 5188,5193 ----
*************** XactLogCommitRecord(TimestampTz commit_t
*** 5220,5225 ****
--- 5220,5228 ----
  						 nsubxacts * sizeof(TransactionId));
  	}
  
+ 	if (xl_xinfo.xinfo & XACT_XINFO_HAS_TWOPHASE)
+ 		XLogRegisterData((char *) (&xl_twophase), sizeof(xl_xact_twophase));
+ 
  	if (xl_xinfo.xinfo & XACT_XINFO_HAS_RELFILENODES)
  	{
  		XLogRegisterData((char *) (&xl_relfilenodes),
*************** XactLogCommitRecord(TimestampTz commit_t
*** 5235,5243 ****
  						 nmsgs * sizeof(SharedInvalidationMessage));
  	}
  
- 	if (xl_xinfo.xinfo & XACT_XINFO_HAS_TWOPHASE)
- 		XLogRegisterData((char *) (&xl_twophase), sizeof(xl_xact_twophase));
- 
  	if (xl_xinfo.xinfo & XACT_XINFO_HAS_ORIGIN)
  		XLogRegisterData((char *) (&xl_origin), sizeof(xl_xact_origin));
  
--- 5238,5243 ----
*************** XactLogAbortRecord(TimestampTz abort_tim
*** 5262,5269 ****
  	xl_xact_abort xlrec;
  	xl_xact_xinfo xl_xinfo;
  	xl_xact_subxacts xl_subxacts;
- 	xl_xact_relfilenodes xl_relfilenodes;
  	xl_xact_twophase xl_twophase;
  
  	uint8		info;
  
--- 5262,5269 ----
  	xl_xact_abort xlrec;
  	xl_xact_xinfo xl_xinfo;
  	xl_xact_subxacts xl_subxacts;
  	xl_xact_twophase xl_twophase;
+ 	xl_xact_relfilenodes xl_relfilenodes;
  
  	uint8		info;
  
*************** XactLogAbortRecord(TimestampTz abort_tim
*** 5291,5308 ****
  		xl_subxacts.nsubxacts = nsubxacts;
  	}
  
- 	if (nrels > 0)
- 	{
- 		xl_xinfo.xinfo |= XACT_XINFO_HAS_RELFILENODES;
- 		xl_relfilenodes.nrels = nrels;
- 	}
- 
  	if (TransactionIdIsValid(twophase_xid))
  	{
  		xl_xinfo.xinfo |= XACT_XINFO_HAS_TWOPHASE;
  		xl_twophase.xid = twophase_xid;
  	}
  
  	if (xl_xinfo.xinfo != 0)
  		info |= XLOG_XACT_HAS_INFO;
  
--- 5291,5308 ----
  		xl_subxacts.nsubxacts = nsubxacts;
  	}
  
  	if (TransactionIdIsValid(twophase_xid))
  	{
  		xl_xinfo.xinfo |= XACT_XINFO_HAS_TWOPHASE;
  		xl_twophase.xid = twophase_xid;
  	}
  
+ 	if (nrels > 0)
+ 	{
+ 		xl_xinfo.xinfo |= XACT_XINFO_HAS_RELFILENODES;
+ 		xl_relfilenodes.nrels = nrels;
+ 	}
+ 
  	if (xl_xinfo.xinfo != 0)
  		info |= XLOG_XACT_HAS_INFO;
  
*************** XactLogAbortRecord(TimestampTz abort_tim
*** 5323,5328 ****
--- 5323,5331 ----
  						 nsubxacts * sizeof(TransactionId));
  	}
  
+ 	if (xl_xinfo.xinfo & XACT_XINFO_HAS_TWOPHASE)
+ 		XLogRegisterData((char *) (&xl_twophase), sizeof(xl_xact_twophase));
+ 
  	if (xl_xinfo.xinfo & XACT_XINFO_HAS_RELFILENODES)
  	{
  		XLogRegisterData((char *) (&xl_relfilenodes),
*************** XactLogAbortRecord(TimestampTz abort_tim
*** 5331,5339 ****
  						 nrels * sizeof(RelFileNode));
  	}
  
- 	if (xl_xinfo.xinfo & XACT_XINFO_HAS_TWOPHASE)
- 		XLogRegisterData((char *) (&xl_twophase), sizeof(xl_xact_twophase));
- 
  	return XLogInsert(RM_XACT_ID, info);
  }
  
--- 5334,5339 ----
